module.exports = {
  react: {
    /**
     * Debug Logs
     */
    debug: true,

    lifecycle: {
      /**
       * Monitor the navigation service switch. The default value is false
       */
      listenNavigation: true,
      /**
       * The data collection rules of component life cycle can be set to specify the fuzzy matching of package path or component name
       */
      collectionRules: {
        /**
         * Allows you to filter the instrumentation for touch events, refresh events and picker events in certain files
         * True = Will be instrumented
         */
        instrument: (filename) => {
          // if (filename.includes("src\\newfile") || filename.includes("src\\otherpath")) {
          //   console.log('filename: ' + filename);
          //   return true;
          // }
          // else return false;
           return true;
        },
        /**
         * 需要上报的 component 组件的生命周期数据,配置规则即正则表达式，注意正则表达式中的 字符转义问题
         */
        componentName: null,
        // componentName: 'Ho+[:0-9a-zA-Z_-]{1,}$', //[\S*]me$, Ho+[:0-9a-zA-Z_-]{1,}$
      },
    },

    input: {
      /**
       * Allows you to filter the instrumentation for touch events, refresh events and picker events in certain files
       * True = Will be instrumented
       */
      instrument: (filename) => {
        return true;
      },
    },
  }
};
