"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.modifyElement = void 0;
const types_1 = require("../model/types");
const OpenRUM_1 = require("./OpenRUMSDK");
const Lifecycle_1 = require("./Lifecycle");
const Logger_1 = require("../../util/Logger");
const Touchable_1 = require("./Touchable");
const Picker_1 = require("./Picker");
function modifyElement(onlyTouch = false, type, props, ...children) {
    if (type._brInfo) {
        if (props) {
            props._brInfo = type._brInfo;
            if (type._brInfo.type === types_1.Types.Button || type._brInfo.type === types_1.Types.Text
                || type._brInfo.type === types_1.Types.TouchableHighlight || type._brInfo.type === types_1.Types.TouchableWithoutFeedback
                || type._brInfo.type === types_1.Types.TouchableOpacity || type._brInfo.type === types_1.Types.TouchableNativeFeedback
                || type._brInfo.type === types_1.Types.Pressable) {
                if (props.onPress) {
                    props.onPress = Touchable_1.TouchableHelper(OpenRUM_1.OpenRUMSDK, Logger_1.Logger).attachOnPress(false, props, children);
                }
                if (props.onLongPress) {
                    props.onLongPress = Touchable_1.TouchableHelper(OpenRUM_1.OpenRUMSDK, Logger_1.Logger).attachOnPress(true, props, children);
                }
            }else if (props.onValueChange && type._brInfo.type === types_1.Types.Picker) {
                props.onValueChange = Picker_1.PickerHelper(OpenRUM_1.OpenRUMSDK, Logger_1.Logger).attachToOnValueChange(props.onValueChange, props.children);
            }
        }
        if (!onlyTouch) {
            
            if (type._brInfo.type === types_1.Types.FunctionalComponent) {
                type = Lifecycle_1.LifecycleHelper(OpenRUM_1.OpenRUMSDK, Logger_1.Logger).attachFunctionalLifecycleListener(type, props);
            }
            else if (type._brInfo.type === types_1.Types.ClassComponent) {
            }
        }
    }
    return type;
}
exports.modifyElement = modifyElement;
